package org.example.domain

import org.example.data.UserRepository
import org.example.domain.Requests.AuthorizeRequest
import org.example.domain.Requests.ChangePasswordRequest
import org.example.domain.Requests.RegistrationRequest
import org.example.domain.Response.UserResponse

class UserUseCaseImpl(private val userRepository: UserRepository): UserUseCase {
    override fun authorize(authorizeRequest: AuthorizeRequest): UserResponse {
        val findUser = userRepository.getAllUsers()
            .firstOrNull {
                it.email == authorizeRequest.email
            }
        checkNotNull(findUser){
            "Пользователь с такой почтой не найден"
        }
        require(findUser.password == authorizeRequest.password){
            "Пароли не совпадают"
        }
        return UserDtoToUserResponse(findUser)
    }

    override fun registration(registrationRequest: RegistrationRequest): UserResponse {
        //уникальность почты
        val isUnique = userRepository.getAllUsers().firstOrNull{
            it.email == registrationRequest.email
        } == null
        require(isUnique){
            "Такая почта уже существует"
        }
        val newUser = userRepository.addUser(registrationRequest)
        return UserDtoToUserResponse(newUser)
    }

    override fun changePassword(changePasswordRequest: ChangePasswordRequest) {
        val updatedUser = userRepository.findUserById(changePasswordRequest.userId)
        updatedUser.password = changePasswordRequest.newPassword
        userRepository.updateUserById(changePasswordRequest.userId, updatedUser)
    }




    override fun changeProfile() {
        TODO("Not yet implemented")
    }
}