package org.example.ui

class MainMenuUI (
    private val userUI: UserUI
){
    val menuItems = listOf(
        "1. Авторизоваться",
        "2. Зарегестрироваться",
        "3. Exit"

    )
    val menuAuthorizedItems = listOf(
        "1. Change password",
        "2. Edit profile",
        "3. Exit"

    )
    private fun displayMenuItem(menuItem: () -> Unit){
        try {
            menuItem()
        }
        catch (e: Exception){
            println(e.message)
            userUI.userAuthorized?.let {
                displayMenuForAuthorizeUser()
            }
        }
    }
    fun displayStartMenu(){
        print(menuItems.joinToString("\n"))
        val menuPosition = readlnOrNull()?.toIntOrNull()
        if(menuPosition == null) displayStartMenu()
        when(menuPosition){
            1 -> {
                displayMenuItem {
                    userUI.authorize()
                    displayMenuForAuthorizeUser()
                }
            }
            2 -> {
                userUI.registration()
            }
            3 ->{
                return
            }
            else -> {
                displayStartMenu()
            }
        }
    }
    private fun displayMenuForAuthorizeUser(){
        print(menuAuthorizedItems.joinToString("\n"))
        val menuPosition = readlnOrNull()?.toIntOrNull()
        if(menuPosition == null) displayMenuForAuthorizeUser()
        when(menuPosition){
            1 -> {
                displayMenuItem {
                    userUI.changePassword()
                }
            }
            2 -> {
                userUI.edit()
            }
            3 -> {
                return
            }
            else -> displayMenuForAuthorizeUser()
        }
    }
}
